/*
 * OSM NB API featuring ETSI NFV SOL005
 * This is Open Source MANO Northbound API featuring ETSI NFV SOL005. For more information on OSM, you can visit [http://osm.etsi.org](http://osm.etsi.org). You can send us your comments and questions to OSM_TECH@list.etsi.org or join the [OpenSourceMANO Slack Workplace](https://join.slack.com/t/opensourcemano/shared_invite/enQtMzQ3MzYzNTQ0NDIyLWVkNTE4ZjZjNWI0ZTQyN2VhOTI1MjViMzU1NWYwMWM3ODI4NTQyY2VlODA2ZjczMWIyYTFkZWNiZmFkM2M2ZDk) 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: OSM_TECH@list.etsi.org
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.lcm.nfvo.osm.rest.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.v3.oas.annotations.media.Schema;

import java.util.Objects;
import java.util.UUID;

/**
 * NsLcmOpOcc
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2022-03-04T13:48:18.253Z[GMT]")
public class NsLcmOpOcc {
  @SerializedName("_id")
  private UUID _id = null;

  @SerializedName("id")
  private UUID id = null;

  @SerializedName("lcmOperationType")
  private String lcmOperationType = null;

  @SerializedName("nsInstanceId")
  private UUID nsInstanceId = null;

  @SerializedName("isAutomaticInvocation")
  private Boolean isAutomaticInvocation = null;

  @SerializedName("isCancelPending")
  private Boolean isCancelPending = null;

  @SerializedName("startTime")
  private Float startTime = null;

  @SerializedName("statusEnteredTime")
  private Float statusEnteredTime = null;

  @SerializedName("operationParams")
  private NsLcmOpOccOperationParams operationParams = null;

  @SerializedName("operationState")
  private String operationState = null;

  @SerializedName("detailed-status")
  private String detailedStatus = null;

  @SerializedName("links")
  private NsLcmOpOccLinks links = null;

  public NsLcmOpOcc _id(UUID _id) {
    this._id = _id;
    return this;
  }

   /**
   * Get _id
   * @return _id
  **/
  @Schema(description = "")
  public UUID getId() {
    return _id;
  }

  public void setId(UUID _id) {
    this._id = _id;
  }

  public NsLcmOpOcc id(UUID id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @Schema(description = "")
  public UUID getIdentifier() {
    return id;
  }

  public void setIdentifier(UUID id) {
    this.id = id;
  }

  public NsLcmOpOcc lcmOperationType(String lcmOperationType) {
    this.lcmOperationType = lcmOperationType;
    return this;
  }

   /**
   * Get lcmOperationType
   * @return lcmOperationType
  **/
  @Schema(description = "")
  public String getLcmOperationType() {
    return lcmOperationType;
  }

  public void setLcmOperationType(String lcmOperationType) {
    this.lcmOperationType = lcmOperationType;
  }

  public NsLcmOpOcc nsInstanceId(UUID nsInstanceId) {
    this.nsInstanceId = nsInstanceId;
    return this;
  }

   /**
   * Get nsInstanceId
   * @return nsInstanceId
  **/
  @Schema(description = "")
  public UUID getNsInstanceId() {
    return nsInstanceId;
  }

  public void setNsInstanceId(UUID nsInstanceId) {
    this.nsInstanceId = nsInstanceId;
  }

  public NsLcmOpOcc isAutomaticInvocation(Boolean isAutomaticInvocation) {
    this.isAutomaticInvocation = isAutomaticInvocation;
    return this;
  }

   /**
   * Get isAutomaticInvocation
   * @return isAutomaticInvocation
  **/
  @Schema(description = "")
  public Boolean isIsAutomaticInvocation() {
    return isAutomaticInvocation;
  }

  public void setIsAutomaticInvocation(Boolean isAutomaticInvocation) {
    this.isAutomaticInvocation = isAutomaticInvocation;
  }

  public NsLcmOpOcc isCancelPending(Boolean isCancelPending) {
    this.isCancelPending = isCancelPending;
    return this;
  }

   /**
   * Get isCancelPending
   * @return isCancelPending
  **/
  @Schema(description = "")
  public Boolean isIsCancelPending() {
    return isCancelPending;
  }

  public void setIsCancelPending(Boolean isCancelPending) {
    this.isCancelPending = isCancelPending;
  }

  public NsLcmOpOcc startTime(Float startTime) {
    this.startTime = startTime;
    return this;
  }

   /**
   * Get startTime
   * @return startTime
  **/
  @Schema(description = "")
  public Float getStartTime() {
    return startTime;
  }

  public void setStartTime(Float startTime) {
    this.startTime = startTime;
  }

  public NsLcmOpOcc statusEnteredTime(Float statusEnteredTime) {
    this.statusEnteredTime = statusEnteredTime;
    return this;
  }

   /**
   * Get statusEnteredTime
   * @return statusEnteredTime
  **/
  @Schema(description = "")
  public Float getStatusEnteredTime() {
    return statusEnteredTime;
  }

  public void setStatusEnteredTime(Float statusEnteredTime) {
    this.statusEnteredTime = statusEnteredTime;
  }

  public NsLcmOpOcc operationParams(NsLcmOpOccOperationParams operationParams) {
    this.operationParams = operationParams;
    return this;
  }

   /**
   * Get operationParams
   * @return operationParams
  **/
  @Schema(description = "")
  public NsLcmOpOccOperationParams getOperationParams() {
    return operationParams;
  }

  public void setOperationParams(NsLcmOpOccOperationParams operationParams) {
    this.operationParams = operationParams;
  }

  public NsLcmOpOcc operationState(String operationState) {
    this.operationState = operationState;
    return this;
  }

   /**
   * Get operationState
   * @return operationState
  **/
  @Schema(description = "")
  public String getOperationState() {
    return operationState;
  }

  public void setOperationState(String operationState) {
    this.operationState = operationState;
  }

  public NsLcmOpOcc detailedStatus(String detailedStatus) {
    this.detailedStatus = detailedStatus;
    return this;
  }

   /**
   * Get detailedStatus
   * @return detailedStatus
  **/
  @Schema(description = "")
  public String getDetailedStatus() {
    return detailedStatus;
  }

  public void setDetailedStatus(String detailedStatus) {
    this.detailedStatus = detailedStatus;
  }

  public NsLcmOpOcc links(NsLcmOpOccLinks links) {
    this.links = links;
    return this;
  }

   /**
   * Get links
   * @return links
  **/
  @Schema(description = "")
  public NsLcmOpOccLinks getLinks() {
    return links;
  }

  public void setLinks(NsLcmOpOccLinks links) {
    this.links = links;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    NsLcmOpOcc nsLcmOpOcc = (NsLcmOpOcc) o;
    return Objects.equals(this._id, nsLcmOpOcc._id) &&
        Objects.equals(this.id, nsLcmOpOcc.id) &&
        Objects.equals(this.lcmOperationType, nsLcmOpOcc.lcmOperationType) &&
        Objects.equals(this.nsInstanceId, nsLcmOpOcc.nsInstanceId) &&
        Objects.equals(this.isAutomaticInvocation, nsLcmOpOcc.isAutomaticInvocation) &&
        Objects.equals(this.isCancelPending, nsLcmOpOcc.isCancelPending) &&
        Objects.equals(this.startTime, nsLcmOpOcc.startTime) &&
        Objects.equals(this.statusEnteredTime, nsLcmOpOcc.statusEnteredTime) &&
        Objects.equals(this.operationParams, nsLcmOpOcc.operationParams) &&
        Objects.equals(this.operationState, nsLcmOpOcc.operationState) &&
        Objects.equals(this.detailedStatus, nsLcmOpOcc.detailedStatus) &&
        Objects.equals(this.links, nsLcmOpOcc.links);
  }

  @Override
  public int hashCode() {
    return Objects.hash(_id, id, lcmOperationType, nsInstanceId, isAutomaticInvocation, isCancelPending, startTime, statusEnteredTime, operationParams, operationState, detailedStatus, links);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class NsLcmOpOcc {\n");
    
    sb.append("    _id: ").append(toIndentedString(_id)).append("\n");
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    lcmOperationType: ").append(toIndentedString(lcmOperationType)).append("\n");
    sb.append("    nsInstanceId: ").append(toIndentedString(nsInstanceId)).append("\n");
    sb.append("    isAutomaticInvocation: ").append(toIndentedString(isAutomaticInvocation)).append("\n");
    sb.append("    isCancelPending: ").append(toIndentedString(isCancelPending)).append("\n");
    sb.append("    startTime: ").append(toIndentedString(startTime)).append("\n");
    sb.append("    statusEnteredTime: ").append(toIndentedString(statusEnteredTime)).append("\n");
    sb.append("    operationParams: ").append(toIndentedString(operationParams)).append("\n");
    sb.append("    operationState: ").append(toIndentedString(operationState)).append("\n");
    sb.append("    detailedStatus: ").append(toIndentedString(detailedStatus)).append("\n");
    sb.append("    links: ").append(toIndentedString(links)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
